' ************************************
' *** ***
' *** Reaktiv-Tiny v0.1 28/11/2005 ***
' *** ***
' ************************************

$regfile = "ATtiny13.DAT"
$crystal = 113000			  'Reale Frequenz des internen 128kHz-Oszillators

Config Portb = &B00011000 		 'Pinb.3 und .4 auf 'Ausgang', Rest auf 'Eingang' schalten
Portb = &B11100111 			'Pullups zuschalten, auer fr Pinb.3 und .4
Stop Adc 				  'A/D-Wandler abschalten, um Strom zu sparen
Stop Ac 				   'Analog-Komparator abschalten, um Strom zu sparen

Dim A As Byte
Dim B As Byte
Dim Led_ladezustand As Bit
Dim Led_lichtcode As Byte
Dim Lichtcode_valid As Bit
Dim Hell As Bit

Lichtcode_valid = 0 		       'Merker lschen (EEPROM-Inhalt wird beim Blinken nicht verwendet)
Gosub Blinken 			     '10 x kurz blinken
Portb.3 = 1
Wait 1 				    '1 x lang blinken (Teach-In-Anfang)
Portb.3 = 0
For A = 1 To 63 			   '63 Bytes des EEPROM's haben wir zur Verfgung
	Gosub Led_abfrage
	If Led_ladezustand = 0 Then        'Wenn LED beleuchtet wurde, dann
		Led_lichtcode = 255        'Lichtcode-Byte setzen
		Lichtcode_valid = 1        'Merker setzen (EEPROM-Inhalt wird beim Blinken verwendet)
	Else 			      'andernfalls
		Led_lichtcode = 0 	 'Lichtcode-Byte lschen
	End If
	Writeeeprom Led_lichtcode , A      'Lichtcode-Byte in's EEPROM schreiben
	Waitms 65 			 '65 ms warten
Next A
For A = 1 To 3
	Portb.3 = 1
	Waitms 50 			 '3 x kurz blinken (Teach-In-Ende)
	Portb.3 = 0
	Waitms 50
Next A
Do
	Gosub Led_abfrage
	If Led_ladezustand = 0 Then 
		Hell = 1 		  'Bei Licht Merker setzen
	End If
	If Hell = 1 And B < 255 Then 
		B = B + 1 		 'Wenn Merker gesetzt wurde, Zhler fr Lichtdauer erhhen (bis max. 255)
	End If
	If Led_ladezustand = 1 And Hell = 1 And B < 50 Then 
		Gosub Blinken 	     'Wenn es wieder dunkel ist und der Lichtimpuls nur kurz war, dann blinken
	End If
	If Led_ladezustand = 1 Then        'Bei Dunkelheit Merker und Zhler fr Lichtdauer lschen
		Hell = 0
		B = 0
	End If
Loop

Led_abfrage:
	Portb.3 = 0 		       'Portb.3 auf Masse schalten
	Portb.4 = 1 		       'Portb.4 auf +Ub schalten, um die LED zu 'laden'
	Waitus 1 			  'Ladezeit, kann ggf. noch verkleinert werden
	Config Portb.4 = Input 	    'Portb.4 nun zwecks Abfrage der LED-Ladung auf 'Eingang' schalten
	Portb.4 = 0 		       'Pullup abschalten, sonst geht's nicht!
	Waitms 20 			 'Entladezeit 20 ms - je kleiner, je unempfindlicher
	Led_ladezustand = Pinb.4 	  'Ladezustand einlesen: '1' -> dunkel, '0' -> hell
	Config Portb.4 = Output 	   'Portb.4 wieder auf Ausgang schalten
	Portb.4 = 0 		       'Portb.4 auf Masse schalten
Return

Blinken:
	Portb.3 = 0
	Portb.4 = 0
	If Lichtcode_valid = 0 Then        'Standard-Blinksequenz (ohne EEPROM-Inhalt)
		For A = 1 To 10
			Portb.3 = 1
			Waitms 50
			Portb.3 = 0
			Waitms 500
		Next A
	Else 			      'Blinksequenz mit EEPROM-Inhalt
		For A = 1 To 63
			Readeeprom Led_lichtcode , A
			If Led_lichtcode = 255 Then
				Portb.3 = 1
			Else
				Portb.3 = 0
			End If
			Waitms 90
		Next A
	End If
Return

End